<?php
/**
 * Since 2015 Ewonta
 *
 * NOTICE OF LICENSE
 *
 * This file is not open source! Each license that you purchased is only available for 1 wesite only.
 * If you want to use this file on more websites (or projects), you need to purchase additional licenses.
 * You are not allowed to redistribute, resell, lease, license, sub-license or offer our resources to any third party.
 *
 *  @author     Ewonta <support@ewonta.ru>
 *  @copyright  Since 2015 Ewonta
 *  @license    Valid for 1 website (or project) for each purchase of license
 */

require_once(_PS_MODULE_DIR_.'ewcryptocloud/vendor/autoload.php');

use Firebase\JWT\JWT;
use Firebase\JWT\Key;

class EwcryptocloudCallbackModuleFrontController extends ModuleFrontController
{
    public function postProcess()
    {
        $id_order = Tools::getValue('order_id');
        $status = Tools::getValue('status');
        $token = Tools::getValue('token');
        try {
            JWT::decode($token, new Key(Configuration::get('EWCRYPTOCLOUD_SECRET_KEY'), 'HS256'));
            $state_success = Configuration::get('EWCRYPTOCLOUD_ID_STATE_SUCCESS');
            $state_fail = Configuration::get('EWCRYPTOCLOUD_ID_STATE_FAIL');
            $order = new Order((int)$id_order);
            if (Validate::isLoadedObject($order) && $status == 'success') {
                $order_history = new OrderHistory();
                $order_history->id_order = (int) $id_order;
                $order_history->changeIdOrderState($state_success, $id_order);
                $order_history->addWithemail(true);
            }
    
            if (Validate::isLoadedObject($order) && $status == 'fail') {
                $order_history = new OrderHistory();
                $order_history->id_order = (int) $id_order;
                $order_history->changeIdOrderState($state_fail, $id_order);
                $order_history->addWithemail(true);
            }

            if (Validate::isLoadedObject($order) && $status == 'canceled') {
                $order_history = new OrderHistory();
                $order_history->id_order = (int) $id_order;
                $order_history->changeIdOrderState($state_fail, $id_order);
                $order_history->addWithemail(true);
            }
    
            header('Content-Type:');
            exit();
        } catch (Exception $e) {
            header('Content-Type:');
            exit();
        }
    }
}