<?php
/**
 * Since 2015 Ewonta
 *
 * NOTICE OF LICENSE
 *
 * This file is not open source! Each license that you purchased is only available for 1 wesite only.
 * If you want to use this file on more websites (or projects), you need to purchase additional licenses.
 * You are not allowed to redistribute, resell, lease, license, sub-license or offer our resources to any third party.
 *
 *  @author     Ewonta <support@ewonta.ru>
 *  @copyright  Since 2015 Ewonta
 *  @license    Valid for 1 website (or project) for each purchase of license
 */

class EwcryptocloudValidationModuleFrontController extends ModuleFrontController
{
    public function postProcess()
    {
        if ($this->module->active == false) {
            die;
        }

        $cart = $this->context->cart;

		if ($cart->id_customer == 0
            || $cart->id_address_delivery == 0
            || $cart->id_address_invoice == 0
            || !$this->module->active) {
            Tools::redirect('index.php?controller=order&step=1');
        }

		$authorized = false;
		foreach (Module::getPaymentModules() as $module) {
            if ($module['name'] == $this->module->name) {
				$authorized = true;
				break;
			}
        }

		if (!$authorized) {
            die($this->module->l('This payment method is not available.', 'validation'));
        }
			
		$customer = new Customer($cart->id_customer);
		if (!Validate::isLoadedObject($customer)) {
            Tools::redirect('index.php?controller=order&step=1');
        }

        $amount = (float) $cart->getOrderTotal(true, Cart::BOTH);

        Context::getContext()->cart = new Cart((int) $cart->id);
        Context::getContext()->customer = new Customer((int) $cart->id_customer);
        Context::getContext()->currency = new Currency((int) Context::getContext()->cart->id_currency);
        Context::getContext()->language = new Language((int) Context::getContext()->customer->id_lang);

        $secure_key = Context::getContext()->customer->secure_key;

        $module_name = $this->module->displayName;
        $currency_id = (int) Context::getContext()->currency->id;
        $permitted_currency = array('USD', 'RUB', 'EUR', 'GBP');


        $this->module->validateOrder(
            $cart->id,
            Configuration::get('EWCRYPTOCLOUD_ID_STATE_AFTER_CREATE'),
            $amount,
            $module_name,
            $message,
            array(),
            $currency_id,
            false,
            $secure_key
        );

        $is_currency = in_array(Context::getContext()->currency->iso_code, $permitted_currency);
        $data_request = array(
			'shop_id' => Configuration::get('EWCRYPTOCLOUD_SHOP_ID'),
			'amount' => number_format($amount, 2, '.', ''),
			'currency' => $is_currency ? Context::getContext()->currency->iso_code : 'USD',
			'order_id' => $this->module->currentOrder,
            'email' => $customer->email
		);

		$curl = curl_init();

		curl_setopt($curl, CURLOPT_POST, 1);
		curl_setopt($curl, CURLOPT_POSTFIELDS, $data_request);

		$headers = array();
		$headers[] = "Authorization: Token " . Configuration::get('EWCRYPTOCLOUD_API_KEY');

		curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
		curl_setopt($curl, CURLOPT_URL, 'https://api.cryptocloud.plus/v1/invoice/create');
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);

		$result = curl_exec($curl);

		curl_close($curl);

		$json_data = json_decode($result, true);
        if ($json_data['status'] == 'success' && $json_data['pay_url']) {
            Tools::redirect($json_data['pay_url'], '');
        } else {
            exit($this->module->getTranslator()->trans('This payment method is not available.', [], 'Modules.Ewcryptocloud.Shop'));
        }
    }
}
